<?php

class Utilities{
    public static function isCurlInstalled(){
        if (in_array('curl', get_loaded_extensions()))
        {
            return 1;
        }
        else
        {
            return 0;
        }
    }

    public static function getdbconnection(){
      $connection = Database::getConnection();
      return $connection;
    }

    /**
     * Guide block
     */
    public static function spConfigGuide(&$form, &$form_state){
        $form['markup_idp_attr_header_top_support'] = array('#markup' => '</div><div class="mo_saml_table_layout_support_1 mo_oauth_container" id="ma_saml_support_query">',);
        $form['miniorange_idp_guide_link1'] = array(
            '#markup' => '<div style="font-size: 15px;"><b>Refer our detailed guide on configuring the module with any OAuth Server: </b></div></br>',
        );

        $form['miniorange_oauth_guide_table_list'] = array(
            '#markup' => '<div class="table-responsive mo_guide_text-center" style="font-family: sans-serif;font-size: 15px;">
                <table class="mo_guide_table mo_guide_table-striped mo_guide_table-bordered" style="border: 1px solid #ddd;max-width: 100%;border-collapse: collapse;">
                    <thead>
                        <tr><th class="mo_guide_text-center" colspan="2"><strong>OAuth Clients</strong></th></tr>
                    </thead>
                    <tbody>
                        <tr><td class="mo_guide_text-center"><a class="mo_guide_text-color" href="https://plugins.miniorange.com/guide-configure-drupal-oauth-server"target="_blank">Custom OAuth Client</a></td> <td class="mo_guide_text-center"><a class="mo_guide_text-color" href="https://plugins.miniorange.com/salesforce-as-oauth-client-with-drupal-oauth-server" target="_blank">Salesforce</a></td></tr>
                        <tr><td class="mo_guide_text-center"><a class="mo_guide_text-color" href="https://plugins.miniorange.com/guide-to-setup-login-into-rocket-chat-with-drupal" target="_blank">Rocket Chat</a></td>   <td class="mo_guide_text-center"><a class="mo_guide_text-color" href="https://plugins.miniorange.com/wordpress-single-sign-on-sso-using-drupal-as-oauth-server" target="_blank">WordPress</a></td></tr>
                        <tr><td class="mo_guide_text-center"><a class="mo_guide_text-color" href="https://plugins.miniorange.com/bitbucket-as-oauth-client-with-drupal-oauth-server" target="_blank">Bitbucket</a></td>                       <td class="mo_guide_text-center"><a class="mo_guide_text-color" href="https://plugins.miniorange.com/joomla-as-oauth-client-with-drupal-oauth-server" target="_blank">Joomla</a></td></tr>
                        <tr><td class="mo_guide_text-center"><a class="mo_guide_text-color" href="https://www.drupal.org/docs/contributed-modules/oauth-server-sso-setup-guides" target="_blank">Other Applications</a></td><td class="mo_guide_text-center"><a class="mo_guide_text-color" href="https://www.drupal.org/docs/contributed-modules/oauth-server-sso-setup-guides/oauth-server-api-documentation" target="_blank">API Documentation</a></td></tr>
                    </tbody>
                </table>
                <div>In case you do not find your desired OAuth Client listed here, please mail us on <a href="mailto:drupalsupport@xecurify.com">drupalsupport@xecurify.com</a>
                    and we will help you to set it up.</div>
            </div>',
        );
    }

    public static function AddsupportTab(&$form, $form_state){
        $form['markup_idp_attr_header_top_support'] = array('#markup' => '</div><div class="mo_saml_table_layout_support_1 mo_oauth_container" id="ma_saml_support_query">',);

        $form['markup_support_1'] = array(
            '#markup' => '<h3><b>Feature Request/Contact Us:</b></h3><div>Need any help? We can help you with configuring your OAuth Client. Just send us a query and we will get back to you soon.<br /></div><br>',
        );

        $form['oauth_server_sso_email_address'] = array(
            '#type' => 'textfield',
            '#id' => 'mo_textfield',
            '#attributes' => array('style'=>'width:100%','placeholder' => 'Enter your email'),
        );

        $form['oauth_server_sso_phone_number'] = array(
            '#type' => 'textfield',
            '#id' => 'mo_textfield',
            '#attributes' => array('style'=>'width:100%','placeholder' => 'Enter your phone number'),
        );

        $form['oauth_server_sso_support_query'] = array(
            '#type' => 'textarea',
            '#cols' => '10',
            '#rows' => '5',
            '#attributes' => array('style'=>'width:100%','placeholder' => 'Write your query here'),
        );

        $form['oauth_server_sso_support_submits'] = array(
            '#type' => 'submit',
            '#value' => t('Submit Query'),
            '#id' => 'button_config_center',
            '#submit' => array('send_support_query'),
        );

        $form['oauth_server_sso_support_note'] = array(
            '#markup' => '<div><br/>If you want custom features in the plugin, just drop an email to <a target="_blank" href="mailto:drupalsupport@xecurify.com">drupalsupport@xecurify.com</a></div>'
        );
    }
    public static function send_query($email, $phone, $query){
        if(empty($email)||empty($query)){
            drupal_set_message(t('The <b><u>Email</u></b> and <b><u>Query</u></b> fields are mandatory.'), 'error');
            return;
        } elseif(!valid_email_address($email)) {
            drupal_set_message(t('The email address <b><i>' . $email . '</i></b> is not valid.'), 'error');
            return;
        }
        $support = new MiniorangeOAuthServerSupport($email, $phone, $query);
        $support_response = $support->sendSupportQuery();
        if($support_response) {
            drupal_set_message(t('Support query successfully sent.'));
        }
        else {
            drupal_set_message(t('Error sending support query. Please reach out to <a target="_blank" href="mailto:drupalsupport@xecurify.com">drupalsupport@xecurify.com</a>'), 'error');
        }
    }

}